Attribute VB_Name = "sb_major"

Public n_pge As Integer         'Number of pages in set.
Public p_n As Integer           'Page number in set.
Public wd As Integer            'Screen width.
Public l_marg As Integer
Public t_marg As Integer
Public print_depth As Integer
Public v_dif As Integer         'Vertical Bar difference.
Public pvp As Integer           'Previous vertical position.
Public bar_width As Integer

Public z_m As Single            'Zoom factor.
Public y_f As Single

Public pge_txt() As String
Public frm_text As String
Public text2 As String
Public path As String           'Application path.

Public setup As Boolean         'Main data set-up flag.
Public canceled As Boolean      'CANCELed flag.
Public cntrl() As Object

Public PP_ps As PPpages         'PP_pages' object.
Public PP_p() As PPpage         'Array for individual 'PP_page' objects.

Sub set_up()

    setup = False
    
    path = App.path + "\"
    
    Set PP_ps = New PPpages     'Define the 'Pages' object and
    preview.set_PPpages PP_ps   'use it to define the Preview form PPpages object.
    
    'Define basic page parameters.
    PP_ps.page_parms vbPRPSA4, vbPRORPortrait, 800, 300, 600, 400, 800, 800, 1

    n_pge = 1 '4        'Declare the number of pages and
    ReDim PP_p(n_pge)   'dimension the page array to fit, (use 1 to n_pge).
    For j = 1 To n_pge
        Set PP_p(j) = PP_ps.Add(j, j + 3)   'Make the LOCAL page numbers 1 - 4 and
    Next                                    'the ABSOLUTE 4 - 7.
 
    frm_text = "This is a long section of text with built in\b/ formatting commands" _
                + ", (the last section\n/ should be in bold). This is to test the " _
                + "various functions of the \i/ 'add_f_text'\n/ routine. This illustrates " _
                + "\s/super\n/scripts and \p/sub\n/scripts. This a change of \20/font size\n/" _
                + " then \u/underline and\t/strikethrough\n/. This shows the use of a backspace O\k/A\n/."

    setup = True

    create_page 1, 1, 1 '4 'Create a page set for Preview.
    
End Sub

'Routine to create a Print/Preview page.
'This is a generalised routine which acts as a container for specific, program routines.
'Its minimum requirements are the three parameters used below.

'It must exist as it is used by the Class routines to re-create specific pages.

'No assumption is made concerning the main program 'PP_page' object. The collection item
'index of the requested page is found and used to define a local 'PP_page' object which
'is used to define the page text.

'It could respond to a main program, option variable to select a variety of outputs.

'Procedure name:    create_page(fl, zm, lpn)
'Parameters:        fl;     the Print/Preview flag,
'                   zm;     the zoom factor, 1 or 1.5 when zoomed in.
'                   lpn;    the LOCAL page number.

Sub create_page(fl, zm, lpn)
 
    'THIS FIRST SECTION IS GENERAL TO ALL PAGES.
    
    p_n = lpn   'Local storage for the page number.
    
    Dim c_p As PPpage, col As Collection    'Declare page and collection objects.
    Dim p_lin, pd, hpp As Integer
    
    indx = PP_ps.find_index((lpn))  'Find the index of the Page 'lpn'.
    If indx > 0 Then                'There is a valid page, so
        Set col = PP_ps.page_col    'define the collection object and
        Set c_p = col(indx)         'the 'PP_page' object.
    
        c_p.set_pp = fl     'Set the Print/Preview flag and
        c_p.set_zoom = zm   'the zoom factor.
        
'******************************CREATE THE PAGE TEXT************************************
'       The following code is application specific.

        c_p.font "Century Gothic", 14   'Set the font name and size.
        
        print_depth = c_p.page_data(2) 'This sets the initial printing at the TOP margin.
        
        c_p.header "Test page", "Arial", 10, True  'Header with default, CENTER, alignment.
    
        c_p.add_f_text frm_text, 0, True, print_depth, 3, p_lin   'Add formatted, FULLY JUSTIFIED text.
 
        pd = 0  'Vertical position variable to return the print depth.
        c_p.add_graphic path + "shd_bdr.jpg", 0.5, , , (pd)
        
        c_p.footer True, "Arial", 10, True  'Footer with default alignments, DATE at LEFT, PAGE NO. CENTRE.
'**************************************************************************************
    
    'THIS FINAL SECTION IS GENERAL TO ALL PAGES.
    
        PP_ps.print_it lpn      'Print/Preview the page.

    Else
        MsgBox "Bad index!", vbOKOnly + vbCritical, "MAIN PROGRAM  ERROR"
        canceled = True
    End If
    
End Sub

